/***************************************************************************
 *   Copyright (C) 2007 by Antony Martin                                   *
 *   martin.antony@yahoo.fr                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/* Cree le : 5 janvier 2007
   derniere modification le 16/01/2007 */

/*
    MediaManager
    Interface, couche 1 (pas sur)
*/

#ifndef __SCEMEDIA_H__
#define __SCEMEDIA_H__

#if 0
    /* types de medias */
    enum sce_enum_media_type
    {
        SCE_MODEL,
        SCE_TEXTURE,
        SCE_SHADER,
        SCE_USER_TYPE,
        SCE_UNKNOW_TYPE
    };
    typedef enum sce_enum_media_type SCE_EMediaType;
#endif

#define SCE_UNKNOW_TYPE (-1)



/* fonction d'initialisation */
int SCE_Media_Init(void);

/* libere la memoire allouee par le MediaManager */
int SCE_Media_Quit(void);


/* fonction de generation d'un identifiant de type */
int SCE_Media_GenTypeID(void);


/* fonction de chargement d'un media */
void* SCE_Media_LoadFromFile(const char*, void*, int*);

/* fonction d'enregistrement d'une fonction de chargement d'un media
   pour un nombre magic et une extension speficies */
int SCE_Media_RegisterLoader(int, int, const char*, void* (*)(FILE*, const char*, void*));


/* fonction de sauvegarde d'un media */
int SCE_Media_SaveToFile(void*, const char*, int);

/* fonction d'enregistrement d'une fonction de sauvegarde d'un media */
int SCE_Media_RegisterSaver(int, int (*)(const char*, void*));

#endif /* guard */
